## opensurge 0.6.1.3+ds

=== CMakeLists.txt ===
#
# Open Surge Engine
# CMakeLists.txt - CMake script
# Copyright 2008-2026  Alexandre Martins <alemartf@gmail.com>
# http://opensurge2d.org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

# ------------------------------------------
# Initialization
# ------------------------------------------

cmake_minimum_required(VERSION 3.20)
project(opensurge LANGUAGES C CXX)

set(CMAKE_C_STANDARD 99)
set(GAME_UNIXNAME "opensurge")
set(GAME_NAME "Open Surge Engine")

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/src/misc/cmake")
set(HELP "Tweak the options or get help at opensurge2d.org")
set(DEFS "") # our #defines

if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
  set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "Debug | Release | MinSizeRel | RelWithDebInfo" FORCE)
  set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS "Debug" "Release" "MinSizeRel" "RelWithDebInfo")
endif()

include(utils)
read_game_version(GAME_VERSION_STRING GAME_VERSION_MAJOR GAME_VERSION_MINOR GAME_VERSION_PATCH GAME_VERSION_BUILD)
read_game_years(GAME_YEARS)

message("${GAME_NAME} version ${GAME_VERSION_STRING}")




# ------------------------------------------
# User options
# ------------------------------------------

option(ALLEGRO_MONOLITH "Use the monolith version of Allegro" OFF)
option(SURGESCRIPT_STATIC "Link SurgeScript statically" OFF)

# Link Allegro statically
option(ALLEGRO_STATIC "Link Allegro statically (Windows only)" OFF)
if(ALLEGRO_STATIC)
  list(APPEND DEFS "ALLEGRO_STATICLINK=1")
endif()

# Run in place?
option(GAME_RUNINPLACE "Read assets only from the directory of the executable" OFF)
if(GAME_RUNINPLACE)
  list(APPEND DEFS "GAME_RUNINPLACE=1")
endif()

# Set the build type & version - this helps identify the platform and the development builds
set(GAME_BUILD_VERSION "" CACHE STRING "Build type & version (optional)")
if(NOT GAME_BUILD_VERSION STREQUAL "")
  list(APPEND DEFS "GAME_BUILD_VERSION=\"${GAME_BUILD_VERSION}\"")
endif()

# Set the build date
option(WANT_BUILD_DATE "Include the build date in the binary (disable for reproducible builds)" ON)
if(WANT_BUILD_DATE)
  list(APPEND DEFS "GAME_BUILD_DATE=__DATE__")
endif()

# Play a MOD (options screen)
option(WANT_PLAYMOD "Display the MOD loader in the options screen" ON)
if(WANT_PLAYMOD)
  list(APPEND DEFS "WANT_PLAYMOD=1")
endif()

# OpenGL ES
option(WANT_GLES "Use OpenGL ES (Android and X11)" OFF)
if(WANT_GLES)
  list(APPEND DEFS "WANT_GLES=1")
endif()

# FastDraw
option(WANT_FASTDRAW "Use the FastDraw mini-library" ON)
if(WANT_FASTDRAW)
  list(APPEND DEFS "WANT_FASTDRAW=1")
endif()

# Improved Gamepad support
option(WANT_BETTER_GAMEPAD "Autodetect gamepad layouts for consistent cross-platform behavior" ON)
if(WANT_BETTER_GAMEPAD)
  list(APPEND DEFS "WANT_BETTER_GAMEPAD=1")
endif()

# User-specified paths
set(ALLEGRO_LIBRARY_PATH "${CMAKE_LIBRARY_PATH}" CACHE PATH "Where to look for Allegro & its dependencies")
set(ALLEGRO_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}" CACHE PATH "Where to look for the header files of Allegro")
set(SURGESCRIPT_LIBRARY_PATH "${CMAKE_LIBRARY_PATH}" CACHE PATH "Where to look for SurgeScript")
set(SURGESCRIPT_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}" CACHE PATH "Where to look for the header files of SurgeScript")
set(PHYSFS_LIBRARY_PATH "${CMAKE_LIBRARY_PATH}" CACHE PATH "Where to look for PhysicsFS")
set(PHYSFS_INCLUDE_PATH "${CMAKE_INCLUDE_PATH}" CACHE PATH "Where to look for the header files of PhysicsFS")

set(GAME_DISTDIR "." CACHE PATH "Installation directory of the game, relative to the build folder, when running in place")

if(UNIX)
  set(GAME_BINDIR "games" CACHE PATH "Installation directory of the executable. It will be appended to CMAKE_INSTALL_PREFIX if it's a relative path")
  set(GAME_DATADIR "share/games/${GAME_UNIXNAME}" CACHE PATH "Installation directory of the game data. It will be appended to CMAKE_INSTALL_PREFIX if it's a relative path")
  set(GAME_USERDIRNAME "${GAME_UNIXNAME}" CACHE PATH "Name of the user-modifiable asset directory")
endif()

if(UNIX AND NOT ANDROID)
  set(DESKTOP_ENTRY_PATH "/usr/share/applications" CACHE PATH "Installation directory of the .desktop file")
  set(DESKTOP_ICON_PATH "/usr/share/icons/hicolor/256x256/apps" CACHE PATH "Installation directory of the icon file")
  set(DESKTOP_METAINFO_PATH "/usr/share/metainfo" CACHE PATH "Installation directory of the metainfo file. You shouldn't change this (check the AppStream specfication)")
endif()

# Data folder
if(UNIX)
  list(APPEND DEFS "GAME_USERDIRNAME=\"${GAME_USERDIRNAME}\"")
  if(IS_ABSOLUTE "${GAME_DATADIR}")
    list(APPEND DEFS "GAME_DATADIR=\"${GAME_DATADIR}\"")
  else()
    list(APPEND DEFS "GAME_DATADIR=\"${CMAKE_INSTALL_PREFIX}/${GAME_DATADIR}\"")
  endif()
endif()




# ------------------------------------------
# Templates
# ------------------------------------------

# Generate the content of the credits screen
csv_to_cstr(COPYRIGHT_DATA_CSV "src/misc/copyright_data.csv")
generate_from_template("credits.c")

# Generate desktop & metadata files
if(DEFINED DESKTOP_ENTRY_PATH)

  # Find absolute paths
  cmake_path(APPEND DESKTOP_ICON_FULLPATH "${DESKTOP_ICON_PATH}" "opensurge.png")
  if(IS_ABSOLUTE "${GAME_BINDIR}")
    cmake_path(APPEND DESKTOP_EXEC_FULLPATH "${GAME_BINDIR}" "${GAME_UNIXNAME}")
  else()
    cmake_path(APPEND DESKTOP_EXEC_FULLPATH "${CMAKE_INSTALL_PREFIX}" "${GAME_BINDIR}" "${GAME_UNIXNAME}")
  endif()

  generate_from_template("opensurge.desktop")
  generate_from_template("opensurge.appdata.xml")

endif()

# Generate the resource file
if(WIN32)
  generate_from_template("opensurge.rc")
endif()




# ------------------------------------------
# Find the dependencies
# ------------------------------------------

include(libs)

# Allegro
find_path(ALLEGRO_INCDIR NAMES "allegro5/allegro.h" PATHS ${ALLEGRO_INCLUDE_PATH})
if(NOT ALLEGRO_INCDIR)
  message(FATAL_ERROR "Can't find allegro.h! ${HELP}")
else()
  message(STATUS "Found allegro.h at ${ALLEGRO_INCDIR}/allegro5")
endif()

set(LALLEGRO_ALL "")
foreach(A5_LIB ${ALLEGRO_LIBS})
  string(TOUPPER "L${A5_LIB}" _A5_LIB)
  find_library(${_A5_LIB} NAMES "${A5_LIB}" PATHS ${ALLEGRO_LIBRARY_PATH})
  if(NOT ${_A5_LIB})
    message(FATAL_ERROR "Can't find lib${A5_LIB}. ${HELP}")
  else()
    message(STATUS "Found lib${A5_LIB} at ${${_A5_LIB}}...")
    list(APPEND LALLEGRO_ALL "${${_A5_LIB}}")
  endif()
endforeach()

# SurgeScript
find_path(SURGESCRIPT_INCDIR NAMES "surgescript.h" PATHS ${SURGESCRIPT_INCLUDE_PATH})
if(NOT SURGESCRIPT_INCDIR)
  message(FATAL_ERROR "Can't find surgescript.h! ${HELP}")
else()
  message(STATUS "Found surgescript.h at ${SURGESCRIPT_INCDIR}")
endif()

find_library(LSURGESCRIPT NAMES "${SURGESCRIPT_LIB}" PATHS ${SURGESCRIPT_LIBRARY_PATH})
if(NOT LSURGESCRIPT)
  message(FATAL_ERROR "Can't find lib${SURGESCRIPT_LIB}! ${HELP}")
else()
  message(STATUS "Found lib${SURGESCRIPT_LIB} at ${LSURGESCRIPT}...")
endif()

# PhysicsFS
find_path(PHYSFS_INCDIR NAMES "physfs.h" PATHS ${PHYSFS_INCLUDE_PATH})
if(NOT PHYSFS_INCDIR)
  message(FATAL_ERROR "Can't find physfs.h! ${HELP}")
else()
  message(STATUS "Found physfs.h at ${PHYSFS_INCDIR}")
endif()

find_library(LPHYSFS NAMES "physfs" PATHS ${PHYSFS_LIBRARY_PATH})
if(NOT LPHYSFS)
  message(FATAL_ERROR "Can't find libphysfs! ${HELP}")
else()
  message(STATUS "Found libphysfs at ${LPHYSFS}...")
endif()




# ------------------------------------------
# Create the executable
# ------------------------------------------

include(srcs)

# Executable
if(WIN32)

  # Windows executable
  if(NOT MSVC)

    find_library(LM m)
    add_executable(${GAME_UNIXNAME} WIN32 ${GAME_SRCS})
    target_link_libraries(${GAME_UNIXNAME} ${LM} ${LSURGESCRIPT} ${LPHYSFS} ${LALLEGRO_ALL})
    target_include_directories(${GAME_UNIXNAME} PUBLIC ${SURGESCRIPT_INCDIR} ${PHYSFS_INCDIR} ${ALLEGRO_INCDIR})
    set_target_properties(${GAME_UNIXNAME} PROPERTIES COMPILE_FLAGS "-Wall")

    if(MINGW)
      if(NOT CMAKE_RC_COMPILER)
        set(CMAKE_RC_COMPILER windres)
      endif()
      execute_process(COMMAND ${CMAKE_RC_COMPILER} -O coff -o "${CMAKE_CURRENT_BINARY_DIR}/opensurge.res" -i "${CMAKE_CURRENT_BINARY_DIR}/src/misc/opensurge.rc" -I "${CMAKE_CURRENT_SOURCE_DIR}/src/misc")
      set_target_properties(${GAME_UNIXNAME} PROPERTIES LINK_FLAGS "-static-libgcc -static-libstdc++ \"${CMAKE_CURRENT_BINARY_DIR}/opensurge.res\"")
    endif()

    if(ALLEGRO_STATIC)
      set_target_properties(${GAME_UNIXNAME} PROPERTIES LINKER_LANGUAGE CXX)
    endif()

  else()

    add_executable(${GAME_UNIXNAME} WIN32 ${GAME_SRCS} ${GAME_HEADERS})
    target_link_libraries(${GAME_UNIXNAME} ${LSURGESCRIPT} ${LPHYSFS} ${LALLEGRO_ALL})
    target_include_directories(${GAME_UNIXNAME} PUBLIC ${SURGESCRIPT_INCDIR} ${PHYSFS_INCDIR} ${ALLEGRO_INCDIR})
    set_target_properties(${GAME_UNIXNAME} PROPERTIES COMPILE_FLAGS "/D_CRT_SECURE_NO_DEPRECATE /D_CRT_SECURE_NO_WARNINGS ${CMAKE_C_FLAGS}")

  endif()

elseif(ANDROID)

  # Android: shared library
  find_library(LM m)
  find_library(LLOG log)
  add_library(${GAME_UNIXNAME} SHARED ${GAME_SRCS})
  target_link_libraries(${GAME_UNIXNAME} ${LM} ${LSURGESCRIPT} ${LPHYSFS} ${LALLEGRO_ALL} ${LLOG})
  target_include_directories(${GAME_UNIXNAME} PUBLIC ${SURGESCRIPT_INCDIR} ${PHYSFS_INCDIR} ${ALLEGRO_INCDIR})
  set_target_properties(${GAME_UNIXNAME} PROPERTIES COMPILE_FLAGS "-Wall")

elseif(UNIX)

  # Unix executable
  find_library(LM m)
  add_executable(${GAME_UNIXNAME} ${GAME_SRCS})
  target_link_libraries(${GAME_UNIXNAME} ${LM} ${LSURGESCRIPT} ${LPHYSFS} ${LALLEGRO_ALL})
  target_include_directories(${GAME_UNIXNAME} PUBLIC ${SURGESCRIPT_INCDIR} ${PHYSFS_INCDIR} ${ALLEGRO_INCDIR})
  set_target_properties(${GAME_UNIXNAME} PROPERTIES COMPILE_FLAGS "-Wall")

endif()

# Our #defines
target_compile_definitions(${GAME_UNIXNAME} PUBLIC ${DEFS})

# Target properties
set_target_properties(${GAME_UNIXNAME} PROPERTIES PROJECT_LABEL "${GAME_NAME}")
if(GAME_RUNINPLACE)
  set_target_properties(${GAME_UNIXNAME} PROPERTIES RUNTIME_OUTPUT_DIRECTORY "${CMAKE_SOURCE_DIR}")
endif()

# Use relative paths in __FILE__ (reproducible builds)
if(NOT MSVC)
  target_compile_options(${GAME_UNIXNAME} PUBLIC "-ffile-prefix-map=${CMAKE_SOURCE_DIR}=.")
endif()




# ------------------------------------------
# Install the game
# ------------------------------------------

include(assets)

if(UNIX AND NOT GAME_RUNINPLACE)

  # Executable
  install(TARGETS "${GAME_UNIXNAME}"
    RUNTIME DESTINATION "${GAME_BINDIR}"
    LIBRARY DESTINATION "${GAME_BINDIR}"
  )

  # Assets
  install(FILES ${ASSET_FILES} DESTINATION "${GAME_DATADIR}")
  install(DIRECTORY ${ASSET_FOLDERS} DESTINATION "${GAME_DATADIR}" PATTERN ".git" EXCLUDE)

  # AppStream / freedesktop.org
  if(DEFINED DESKTOP_ENTRY_PATH)
    install(FILES src/misc/opensurge.png DESTINATION "${DESKTOP_ICON_PATH}")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/src/misc/opensurge.appdata.xml" DESTINATION "${DESKTOP_METAINFO_PATH}")
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/src/misc/opensurge.desktop" DESTINATION "${DESKTOP_ENTRY_PATH}")
  endif()

elseif(GAME_RUNINPLACE)

  # Portable executable & assets
  install(TARGETS "${GAME_UNIXNAME}" RUNTIME DESTINATION "${GAME_DISTDIR}")
  install(FILES ${ASSET_FILES} DESTINATION "${GAME_DISTDIR}")
  install(
    DIRECTORY ${ASSET_FOLDERS} screenshots
    DESTINATION "${GAME_DISTDIR}"
    PATTERN ".git" EXCLUDE
    PATTERN "screenshots/*.png" EXCLUDE

=== src/misc/android/Makefile ===
#
# Build scripts for the Android edition of the Open Surge Engine
# Copyright 2024-present Alexandre Martins <http://opensurge2d.org>
# License: GPL-3.0-or-later
#

# ------------------------------------------------------------------------------
# The build process is divided into phases:
# ------------------------------------------------------------------------------
#
# 1. Initialization phase
#    Create the build/ folder and set up its basic structure.
#
# 2. Pull / download phase
#    Get the source code of each part: deps, allegro, surgescript, opensurge and
#    java. The source code of each part is stored in build/parts/<part>/src/.
#
# 3. Build phase
#    Compile each part. C/C++ code is typically compiled for multiple ABIs.
#    The build artifacts are stored in build/parts/<part>/build/[<abi>/].
#
# 4. Stage phase
#    After compiling, binaries and assets are installed in build/stage/. This
#    phase is intertwined with the build phase, as some parts depend on others.
#
# 5. Assemble phase
#    Package code and data into an APK file. The output APK is unsigned. Before
#    packaging, binaries and assets in build/stage/ are organized in build/apk/.
#
# ------------------------------------------------------------------------------

.PHONY: all apk signed run clean version

-include .rebuild_trigger
include settings.mk

# Compute the version code and the version name
# Version a.b.c.d is such that a,b,c,d >= 0; b,c < 10; d < 50
VERSION_CODE := $(shell expr "$(GAME_VERSION_MAJOR)" \* 5000 + "$(GAME_VERSION_MINOR)" \* 500 + "$(GAME_VERSION_PATCH)" \* 50 + "$(GAME_VERSION_BUILD)")
VERSION_NAME := $(GAME_VERSION_MAJOR).$(GAME_VERSION_MINOR).$(GAME_VERSION_PATCH).$(GAME_VERSION_BUILD)-$(GAME_VERSION_SUFFIX)

ifneq ($(shell test "$(GAME_VERSION_MINOR)" -ge 10 -o "$(GAME_VERSION_PATCH)" -ge 10 -o "$(GAME_VERSION_BUILD)" -ge 50 && echo x),)
$(error Invalid version: $(VERSION_NAME))
endif

ifneq ($(FORCE_VERSION_NAME),)
VERSION_NAME := $(FORCE_VERSION_NAME)-$(GAME_VERSION_SUFFIX)
endif

# Helpers
FINISH_TASK = @touch $@
CLEAN_TASK = rm -f ./$(subst .clean_,.,$@)



#
# Public targets
#

all: apk

apk: .assemble
	
signed: apk
	scripts/sign_apk.sh -K "$(DEBUG_KEYSTORE)"

run: apk
	scripts/run_apk.sh -S "$(SDK)" -b "$(BUILD_TOOLS_VERSION)"

clean: .clean

version:
	@echo "$(VERSION_CODE)" "$(VERSION_NAME)"



#
# Assemble phase
#

.assemble: .assemble_prepare .assemble_package
	@echo "The APK is available at the build/ folder"
	@echo "Sign the APK with a debug key: make signed"
	@echo "Run the engine: make run (sign it first)"
	@echo "Cleanup: make clean"
	$(FINISH_TASK)

.assemble_prepare: .stage
	scripts/assemble_prepare.sh
	$(FINISH_TASK)

.assemble_package: .assemble_prepare
	scripts/assemble_package.sh -v "$(VERSION_CODE)" -x "$(VERSION_NAME)" -p "$(GAME_APPLICATION_ID)"
	$(FINISH_TASK)



#
# Stage phase
#

.stage: .stage_deps .stage_allegro .stage_surgescript .stage_opensurge .stage_java
	$(FINISH_TASK)

.stage_deps: .build_deps
	for abi in $(ABI_LIST); do \
		scripts/stage_deps.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.stage_allegro: .build_allegro
	for abi in $(ABI_LIST); do \
		scripts/stage_allegro.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.stage_surgescript: .build_surgescript
	for abi in $(ABI_LIST); do \
		scripts/stage_surgescript.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.stage_opensurge: .build_opensurge
	for abi in $(ABI_LIST); do \
		scripts/stage_opensurge.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.stage_java: .build_java
	scripts/stage_java.sh
	$(FINISH_TASK)



#
# Build phase
#

.build: .build_deps .build_allegro .build_surgescript .build_opensurge .build_java
	$(FINISH_TASK)

.build_deps: .pull_deps
	for abi in $(ABI_LIST); do \
		scripts/build_deps.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.build_allegro: .pull_allegro .stage_deps
	for abi in $(ABI_LIST); do \
		scripts/build_allegro.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.build_surgescript: .pull_surgescript
	for abi in $(ABI_LIST); do \
		scripts/build_surgescript.sh -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.build_opensurge: .pull_opensurge .stage_surgescript .stage_allegro
	for abi in $(ABI_LIST); do \
		scripts/build_opensurge.sh -v "$(GAME_VERSION_SUFFIX)" -a $$abi -N "$(NDK)" -m "$(NDK_API_LEVEL)"; \
	done
	$(FINISH_TASK)

.build_java: .pull_java .stage_allegro
	scripts/build_java.sh -S "$(SDK)" -c "$(COMPILE_SDK_VERSION)" -b "$(BUILD_TOOLS_VERSION)"
	$(FINISH_TASK)



#
# Pull phase
#

.pull: .pull_deps .pull_allegro .pull_surgescript .pull_opensurge .pull_java
	$(FINISH_TASK)

.pull_deps: .init
	scripts/pull_deps.sh
	$(FINISH_TASK)

.pull_allegro: .init
	scripts/pull_allegro.sh
	$(FINISH_TASK)

.pull_surgescript: .init
	scripts/pull_surgescript.sh
	$(FINISH_TASK)

.pull_opensurge: .init
	scripts/pull_opensurge.sh
	$(FINISH_TASK)

.pull_java: .init
	scripts/pull_java.sh
	$(FINISH_TASK)



#
# Initialization phase
#

.init:
	chmod +x scripts/*.sh
	scripts/init.sh
	$(FINISH_TASK)



#
# Clean
#

.clean: .clean_init
	rm -f .rebuild_trigger

.clean_init: .clean_pull
	rm -rf build
	$(CLEAN_TASK)

.clean_pull: .clean_build .clean_pull_deps .clean_pull_allegro .clean_pull_surgescript .clean_pull_opensurge .clean_pull_java
	$(CLEAN_TASK)

.clean_build: .clean_stage .clean_build_deps .clean_build_allegro .clean_build_surgescript .clean_build_opensurge .clean_build_java
	$(CLEAN_TASK)

.clean_stage: .clean_assemble .clean_stage_deps .clean_stage_allegro .clean_stage_surgescript .clean_stage_opensurge .clean_stage_java
	$(CLEAN_TASK)

.clean_assemble: .clean_assemble_prepare .clean_assemble_package
	$(CLEAN_TASK)

# pull
.clean_pull_deps: .clean_build_deps
	rm -rf build/parts/deps/src/*
	$(CLEAN_TASK)

.clean_pull_allegro: .clean_build_allegro
	rm -rf build/parts/allegro/src/*
	$(CLEAN_TASK)

.clean_pull_surgescript: .clean_build_surgescript
	rm -rf build/parts/surgescript/src/*
	$(CLEAN_TASK)

.clean_pull_opensurge: .clean_build_opensurge
	rm -rf build/parts/opensurge/src/*
	$(CLEAN_TASK)

.clean_pull_java: .clean_build_java
	rm -rf build/parts/java/src/*
	$(CLEAN_TASK)

# build
.clean_build_deps: .clean_stage_deps
	rm -rf build/parts/deps/build/*/*
	$(CLEAN_TASK)

.clean_build_allegro: .clean_stage_allegro
	rm -rf build/parts/allegro/build/*/*
	$(CLEAN_TASK)

.clean_build_surgescript: .clean_stage_surgescript
	rm -rf build/parts/surgescript/build/*/*
	$(CLEAN_TASK)

.clean_build_opensurge: .clean_stage_opensurge
	rm -rf build/parts/opensurge/build/*/*
	$(CLEAN_TASK)

.clean_build_java: .clean_stage_java
	rm -rf build/parts/java/build/*
	$(CLEAN_TASK)

# stage
# no make uninstall per part
.clean_stage_deps: .clean_assemble
	rm -rf build/stage/sysroot/*/*
	$(CLEAN_TASK)

.clean_stage_allegro: .clean_assemble
	rm -rf build/stage/sysroot/*/*
	rm -rf build/stage/libs/*
	$(CLEAN_TASK)

.clean_stage_surgescript: .clean_assemble
	rm -rf build/stage/sysroot/*/*
	$(CLEAN_TASK)

.clean_stage_opensurge: .clean_assemble
	rm -rf build/stage/sysroot/*/*
	$(CLEAN_TASK)

.clean_stage_java: .clean_assemble
	rm -f build/stage/*.*
	rm -rf build/stage/res/*
	$(CLEAN_TASK)

# assemble
.clean_assemble_prepare: .clean_assemble_package
	rm -f build/apk/*.*
	rm -rf build/apk/lib/*
	rm -rf build/apk/res/*
	rm -rf build/apk/assets/*
	$(CLEAN_TASK)

.clean_assemble_package:
	rm -f build/*.apk
	$(CLEAN_TASK)

# This helper rebuilds the engine whenever changes are made to settings.mk
.rebuild_trigger: settings.mk #Makefile
	@touch $@
	@$(MAKE) .clean_build

# Helper for development
.recompile_opensurge: .clean_stage .clean_pull_opensurge .pull_opensurge apk

=== debian/changelog ===
opensurge (0.6.1.3+ds-1) unstable; urgency=medium

  * Initial release (Closes: #943676)

 -- Sébastien Noel <sebastien@twolife.be>  Sun, 08 Feb 2026 14:47:56 +0100

=== debian/control ===
Source: opensurge
Section: games
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Carlos Donizete Froes <coringao@riseup.net>, Sébastien Noel <sebastien@twolife.be>
Build-Depends: cmake,
               debhelper-compat (= 13),
               liballegro-acodec5-dev,
               liballegro-audio5-dev,
               liballegro-dialog5-dev,
               liballegro-image5-dev,
               liballegro-ttf5-dev,
               liballegro-physfs5-dev,
               liballegro5-dev,
               libsurgescript-dev
Standards-Version: 4.7.3
Homepage: https://opensurge2d.org
Vcs-Browser: https://salsa.debian.org/games-team/opensurge
Vcs-Git: https://salsa.debian.org/games-team/opensurge.git

Package: opensurge
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
         opensurge-data (= ${source:Version})
Description: Fun 2D retro platformer inspired by Sonic games
 Open Surge is a retro-style 2D sidescroller inspired by old-school games.
 .
 Join Surge, Neon and Charge and save the world from the evil Gimacian
 the Dark!
 .
 It has a game creation system that lets you unleash your creativity.
 Play, create games & share!

Package: opensurge-data
Architecture: all
Depends: ${misc:Depends},
         fonts-roboto-unhinted,
         fonts-noto-core,
         fonts-noto-extra
Suggests: opensurge
Description: Fun 2D retro platformer inspired by Sonic games - Game data
 You probably do not want to install this package manually. Please install
 opensurge to play the Open Surge game!
 .
 This package contains architecture-independent game data for Open Surge.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -fPIE
export DEB_LDFLAGS_MAINT_APPEND = -pie

%:
	dh $@

override_dh_install:
	# filename must match component ID
	mv debian/tmp/usr/share/metainfo/opensurge.appdata.xml debian/tmp/usr/share/metainfo/org.opensurge2d.OpenSurge.appdata.xml
	# Avoid installation of documentation outside /usr/share/doc to make
	# lintian happy
	dh_install --all \
	    --exclude=LICENSE \
	    --exclude=README.txt \
	    --exclude=readme.txt \
	    --exclude=licenses/* \
	    --exclude=README.md \
	    --exclude=CONTRIBUTING.md \
	    --exclude=CHANGELOG.md

=== debian/watch ===
Version: 5
Template: Github
Owner: alemart
Project: opensurge
Repack: yes
Repacksuffix: +ds
Dversion-Mangle: auto
